'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _htmlTags = require('html-tags');

var _htmlTags2 = _interopRequireDefault(_htmlTags);

var _postcssLibStringifier = require('postcss/lib/stringifier');

var _postcssLibStringifier2 = _interopRequireDefault(_postcssLibStringifier);

var _postcssSelectorParser = require('postcss-selector-parser');

var _postcssSelectorParser2 = _interopRequireDefault(_postcssSelectorParser);

var _postcssValueParser = require('postcss-value-parser');

var _postcssValueParser2 = _interopRequireDefault(_postcssValueParser);

var mediaTypes = ['all', 'aural', 'braille', 'embossed', 'handheld', 'print', 'projection', 'screen', 'tty', 'tv'];

var vendors = ['-webkit-', '-moz-', '-ms-', '-o-'];

var span = function span(text, element) {
    return '<span class="midas__' + element + '">' + text + '</span>';
};

var MidasStringifier = (function (_Stringifier) {
    _inherits(MidasStringifier, _Stringifier);

    function MidasStringifier() {
        _classCallCheck(this, MidasStringifier);

        _get(Object.getPrototypeOf(MidasStringifier.prototype), 'constructor', this).apply(this, arguments);
    }

    _createClass(MidasStringifier, [{
        key: 'atrule',
        value: function atrule(node, semicolon) {
            var name = span('@' + node.name, 'at-rule-name');
            var params = node.params ? this.rawValue(node, 'params') : '';

            if (params) {
                var parsed = (0, _postcssValueParser2['default'])(this.rawValue(node, 'params'));
                parsed.nodes.forEach(function (child) {
                    if (child.type === 'string') {
                        var quote = child.quote;
                        child.value = span(quote + child.value + quote, 'string');
                        child.quote = null;
                        return;
                    }
                    if (~mediaTypes.indexOf(child.value) && node.name === 'media') {
                        child.value = span(child.value, 'at-rule-keyword');
                        return;
                    }
                    if (child.type === 'function' && !child.value) {
                        child.nodes.forEach(function (n) {
                            if (n.value.lastIndexOf(':') === n.value.length - 1) {
                                var p = n.value.slice(0, n.value.length - 1);
                                n.value = span(p, 'property') + span(':', 'colon');
                            }
                            if (n.type === 'word') {
                                var number = (0, _postcssValueParser.unit)(n.value);
                                if (number) {
                                    n.value = span(n.value, 'number');
                                    return;
                                }
                            }
                        });
                        child.value = span('(', 'parenthesis') + (0, _postcssValueParser.stringify)(child.nodes) + span(')', 'parenthesis');
                        child.nodes = null;
                    }
                });
                params = (0, _postcssValueParser.stringify)(parsed);
            }

            if (typeof node.raws.afterName !== 'undefined') {
                name += node.raws.afterName;
            } else if (params) {
                name += ' ';
            }

            if (node.nodes) {
                this.block(node, span(name + params, 'at-rule'));
            } else {
                var semi = semicolon ? span(';', 'semicolon') : '';
                var end = (node.raws.between || '') + semi;
                this.builder(span(name + params + end, 'at-rule'), node);
            }
        }
    }, {
        key: 'block',
        value: function block(node, start) {
            var between = this.raw(node, 'between', 'beforeOpen');
            this.builder('' + start + between + span('{', 'brace'), node, 'start');

            var after = undefined;
            if (node.nodes && node.nodes.length) {
                this.body(node);
                after = this.raw(node, 'after');
            } else {
                after = this.raw(node, 'after', 'emptyBody');
            }

            if (after) {
                this.builder(after);
            }
            this.builder(span('}', 'brace'), node, 'end');
        }
    }, {
        key: 'comment',
        value: function comment(node) {
            var left = this.raw(node, 'left', 'commentLeft');
            var right = this.raw(node, 'right', 'commentRight');
            this.builder(span('/*' + left + node.text + right + '*/', 'comment'), node);
        }
    }, {
        key: 'decl',
        value: function decl(node, semicolon) {
            var between = span(this.raw(node, 'between', 'colon'), 'colon');
            var parsed = (0, _postcssValueParser2['default'])(this.rawValue(node, 'value'));
            var transform = function transform(node) {
                if (node.type === 'string') {
                    var quote = node.quote;
                    node.value = span(quote + node.value + quote, 'string');
                    node.quote = null;
                    return;
                }
                if (node.type === 'word') {
                    var number = (0, _postcssValueParser.unit)(node.value);
                    if (number) {
                        node.value = span(node.value, 'number');
                        return;
                    }
                    if (!node.value.indexOf('#')) {
                        var value = span(node.value.slice(1), 'hex-value');
                        node.value = span('#' + value, 'hex-color');
                        return;
                    }
                    node.value = span(node.value, 'word');
                    return;
                }
                if (node.type === 'function') {
                    node.nodes.forEach(transform);
                    node.value = span(span(node.value, 'function-name') + span('(', 'parenthesis') + (0, _postcssValueParser.stringify)(node.nodes) + span(')', 'parenthesis'), 'function');
                    node.nodes = null;
                }
            };
            parsed.nodes.forEach(transform);
            vendors.some(function (vendor) {
                if (~node.prop.indexOf(vendor)) {
                    var prefix = span(vendor, 'vendor-prefix');
                    node.prop = node.prop.replace(vendor, prefix);
                }
            });

            var prop = span(node.prop, 'property');
            var string = prop + between + span(String(parsed), 'value');

            if (node.important) {
                string += span(node.raws.important || ' !important', 'important');
            }

            if (semicolon) {
                string += span(';', 'semicolon');
            }
            this.builder(string, node);
        }
    }, {
        key: 'root',
        value: function root(node) {
            this.builder('<pre class="midas"><code>');
            _get(Object.getPrototypeOf(MidasStringifier.prototype), 'root', this).call(this, node);
            this.builder('</code></pre>');
        }
    }, {
        key: 'rule',
        value: function rule(node) {
            if (node.selector) {
                this.selector(node);
            }
            this.block(node, span(this.rawValue(node, 'selector'), 'selector'));
        }
    }, {
        key: 'selector',
        value: function selector(node) {
            var transform = function transform(selectors) {
                selectors.eachInside(function (sel) {
                    if (sel.type === 'tag' && ~_htmlTags2['default'].indexOf(sel.value)) {
                        sel.value = span(sel.value, 'tag');
                    }
                    if (sel.type === 'attribute') {
                        sel.toString = function () {
                            var selector = [this.spaces.before, span('[', 'attribute-brace'), this.ns, span(this.attribute, 'attribute-name')];

                            if (this.operator) {
                                var op = span(this.operator, 'attribute-operator');
                                selector.push(op);
                            }
                            if (this.value) {
                                selector.push(span(this.value, 'attribute-value'));
                            }
                            var ai = 'attribute-insensitive';
                            if (this.raw.insensitive) {
                                var ci = span(this.raw.insensitive, ai);
                                selector.push(ci);
                            } else if (this.insensitive) {
                                selector.push(span(' i'), ai);
                            }
                            selector.push(span(']', 'attribute-brace'));
                            var str = selector.concat(this.spaces.after).join('');
                            return span(str, 'attribute');
                        };
                    }
                    if (sel.type === 'pseudo') {
                        sel.toString = function () {
                            var params = this.length ? span('(', 'parenthesis') + this.map(String).join(',') + span(')', 'parenthesis') : '';

                            return [this.spaces.before, span(String(this.value), 'pseudo'), params, this.spaces.after].join('');
                        };
                    }
                    if (sel.type === 'class') {
                        sel.toString = function () {
                            return [this.spaces.before, this.ns, span(String('.' + this.value), 'class'), this.spaces.after].join('');
                        };
                    }
                    if (sel.type === 'id') {
                        sel.toString = function () {
                            return [this.spaces.before, this.ns, span(String('#' + this.value), 'id'), this.spaces.after].join('');
                        };
                    }
                    if (sel.type === 'universal') {
                        sel.value = span(sel.value, 'universal');
                    }
                    if (sel.type === 'combinator') {
                        sel.value = span(sel.value, 'combinator');
                    }
                });
            };

            node.selector = (0, _postcssSelectorParser2['default'])(transform).process(node.selector).result;
        }
    }]);

    return MidasStringifier;
})(_postcssLibStringifier2['default']);

exports['default'] = MidasStringifier;
module.exports = exports['default'];